eval " use ReDIF::Parser::Input; ";

test( not( $@ ), $@ );

use ReDIF::Parser::Input;

# ReDIF::Parser::Input

my $r = ReDIF::Parser::Input::start_file( "t/1995.rdf" );

test( $r );
test( defined $ReDIF::Parser::Input::SOURCE_ENCODING );
test( $ReDIF::Parser::Input::SOURCE_ENCODING eq 'latin1' );
test( $ReDIF::Parser::Input::CURRENT_BUFFER_POSITION ==0 );
#print 'BUFFER = "',  
#    $ReDIF::Parser::Input::BUFFER, "\"\n";

# test( $ReDIF::Parser::Input::BUFFER =~ /template-type/i );

my $EOL = unpack ( "H2", &ReDIF::Parser::Input::get_line_ending() );

print "line ending: $EOL\n" ;

test( $EOL eq '0a' );

$r = ReDIF::Parser::Input::extract_next_line( 0 );

test ( $r );

my $line = ReDIF::Parser::Input::get_the_line( );
my $line_length = ReDIF::Parser::Input::get_the_line_length( );

print "LINE: [$line] ($line_length)\n";

#test(1) ;
test( ( defined $line and $line eq "" ), unpack('H10', $line) );
test( defined $line_length and $line_length == 0 );
#test( $ReDIF::Parser::Input::CURRENT_BUFFER_POSITION == 1 ); 

$r = ReDIF::Parser::Input::extract_next_line( 0 );

test ( $r );

$line = ReDIF::Parser::Input::get_the_line( );
$line_length = ReDIF::Parser::Input::get_the_line_length( );

test( defined $line and ($line =~ /^template-type: /i ) );
test( defined $line_length and $line_length == 30 );

print "LINE: $line\nLENGTH $line_length\n";
#print "CUR_BUF_POS: " , $ReDIF::Parser::Input::CURRENT_BUFFER_POSITION, "\n";

#test( $ReDIF::Parser::Input::CURRENT_BUFFER_POSITION == 32 ); 

$r = ReDIF::Parser::Input::extract_next_line( 0 );

test ( $r );

$line = ReDIF::Parser::Input::get_the_line( );
$line_length = ReDIF::Parser::Input::get_the_line_length( );

print "LINE: $line\nLENGTH $line_length\n";

test( defined $line and ($line =~ /^author-name: /i ) );
test( defined $line_length and $line_length == 28 );

$r = ReDIF::Parser::Input::extract_next_line( 0 );
$r = ReDIF::Parser::Input::extract_next_line( 0 );
$r = ReDIF::Parser::Input::extract_next_line( 0 );
$r = ReDIF::Parser::Input::extract_next_line( 0 );
$r = ReDIF::Parser::Input::extract_next_line( 0 );

$n = test( ($r), &ReDIF::Parser::Input::get_the_line() ) ;
print " $n should fail\n";

$line = ReDIF::Parser::Input::get_the_line( );
$line_length = ReDIF::Parser::Input::get_the_line_length( );

test( defined $line and ($line =~ /^author-workplace-name: /i ) );
test( defined $line and ($line =~ /rio$/ ) );
$n = test( defined $line_length and $line_length > 50 );

# $r = ReDIF::Parser::Input::extract_next_line( 0 );

# test( not $r );

# $r = ReDIF::Parser::Input::get_more_data_to_the_buffer( );
# test( $r ) ;


# test( $ReDIF::Parser::Input::CURRENT_FILE_POSITION < 350 , 
#        "CUR_FILE_POS: $ReDIF::Parser::Input::CURRENT_FILE_POSITION" );
# test( $ReDIF::Parser::Input::CURRENT_FILE_POSITION > 280, 
#        "CUR_FILE_POS: $ReDIF::Parser::Input::CURRENT_FILE_POSITION" );



$r = ReDIF::Parser::Input::extract_next_line( 0 );
$r = ReDIF::Parser::Input::extract_next_line( 0 );
$r = ReDIF::Parser::Input::extract_next_line( 0 );

$line = ReDIF::Parser::Input::get_the_line( );
$line_length = ReDIF::Parser::Input::get_the_line_length( );

test( (defined $line and 
       ($line =~ /^ fertility dynamics using an econometric/ ) )?1:0, $line );
test( defined $line and ($line =~ /several$/ ) );
$n = test( defined $line_length and $line_length > 50 );

while( $r ) {
    $r = ReDIF::Parser::Input::extract_next_line( 0 );
}

test( not $r ) ;

#$r = ReDIF::Parser::Input::get_more_data_to_the_buffer( );
#test( $r ) ;
$r = ReDIF::Parser::Input::extract_next_line( 0 );
# test( $r, $ReDIF::Parser::Input::BUFFER ) ;


# test( $ReDIF::Parser::Input::CURRENT_FILE_POSITION < 800 , 
#        "CUR_FILE_POS: $ReDIF::Parser::Input::CURRENT_FILE_POSITION" );
# test( $ReDIF::Parser::Input::CURRENT_FILE_POSITION > 700, 
#        "CUR_FILE_POS: $ReDIF::Parser::Input::CURRENT_FILE_POSITION" );





my @res = ReDIF::Parser::Input::process_file( 't/ctlseri.rdf', 0 );

test( ( @res ? 1: 0 ), join( ':', @res ) );

my $eof_reached   = $res[0];
my $lines_array   = $res[1];
my $lengths_array = $res[2];

$n = test( $eof_reached );

my $i= 0; 
foreach my $l ( @$lines_array ) {

    my $len = sprintf "%02i", $l->{length};
    my $n   = sprintf "%02i", $i; 
    my $p   = sprintf "%03i", $l->{pos}; 
    my $t   = $l->{text}; 
    print "[$n:$p $len] $t";
    $i ++;
}

test( (scalar @$lines_array > 10) );


$r = ReDIF::Parser::Input::start_file( 't/ctlseri.rdf', 0 );
test($r);

while( $r ) {
    $r = ReDIF::Parser::Input::extract_next_line_self_sufficient();
    if( $r ) {
	$line = ReDIF::Parser::Input::get_the_line( );
	$line_length = ReDIF::Parser::Input::get_the_line_length( );

	chomp ($line) ;
	print "L[$line_length]: '$line'\n";
	
    }
}


{ 
    package TEST;
    use strict;
    use vars qw( @EVENTS );
    
    sub the_attribute {
	my $self = shift;
	my @args = @_;
	my $event = [ 'the_attribute', @args ];
	push @EVENTS, $event;
    }


    sub close_current_template {
        my $self = shift;
	my @args = @_;
	my $event = [ 'close_current_template', @args ];
	push @EVENTS, $event;
    }

}


ReDIF::Parser::Input::init( { attribute_output => 'TEST' } );

$r = ReDIF::Parser::Input::start_file( 't/input.data', 0 );
while( defined $r ) {
    $r = ReDIF::Parser::Input::extract_next_attribute();
#    if ( defined $r ) {	
#	print "A: '$r->{attribute}' V: '$r->{value}' P: $r->{file_position} ",
#	"LN: $r->{line_number}\n";
#    }
# print ".";
}

my $result_events = \@TEST::EVENTS;
my $c = 0;
foreach my $ev ( @$result_events ) {
    print "event $c: >>>", join ( ', ', @$ev ), "<<<\n"; 
}



###############################################################
#############     TESTING   FRAMEWORK     #####################
###############################################################

sub test {
    push @TESTS, shift;
    push @MESSAGES, shift;
}

sub ok { 
    push @TESTS, 1; 
    push @MESSAGES, shift;
}
sub nok { 
    push @TESTS, 0; 
    push @MESSAGES, shift;
}



END { 

    my $tests = scalar @TESTS;

    if( not $tests ) {
	print "1..1\nnot ok 1\n";
	exit;
    }

    print "1..$tests\n";

    my $counter = 1;
    while ( 1 ) {
	my $t = shift @TESTS;
	my $m = shift @MESSAGES;
	if( not $t ) {
	    print "not ";
	}
	print "ok $counter\n";

	if( $m ) { 
	    print "[$counter] $m\n";
	}
	last if not scalar @TESTS;
	$counter ++;
    }
}
